/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

Ext.ns('AS.ARC.asusSyncAgent');

/**
 * @class AS.ARC.apps.asusSyncAgent.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */
Ext.define('AS.ARC.apps.asusSyncAgent.core', {
	extend: 'Ext.util.Observable',
	
	apiUrl: AS.ARC.util.getUserAppsPath() + 'asus-sync-agent/syncagent.cgi',
	imageUrl: AS.ARC.util.getUserAppsPath() + 'asus-sync-agent/images/',
	
	constructor: function (config) {
		Ext.apply(this, config);
		
		this.callParent();
		
		this.init();
	},
	
	init: function () {
		var fn = this;
		
	// Field validation Vtypes
	
		fn.win = fn.desktop.createWindow({
			app: fn.app,
			id: fn.id,
			itemId: fn.id,
			width: 880,
			height: 526,
			resizable: false,
			border: false,
			layout: 'border',
			bodyStyle: 'padding: 0; border: none; background: #FFFFFF;',
			items: [
				fn.getMainPanel(),
				fn.getWestPanel()
			],
			listeners: {
				afterrender: function (win) {
					win.header.items.items[1].hide();
					fn.mainPanel.loadData();
				}
			}
		});
	},
	getWestPanel: function () {
		var fn = this;
		
		fn.westPanel = Ext.create('AS.ARC.fnFormPanel', {
			cls: 'as-page-panel',
			page: fn,
			region: 'west',
			width: 245,
			height: 500,
			bodyStyle: 'border:none;background:transparent;',
			style: 'background-image: url("' + fn.imageUrl + 'left_border.png");' 
				+ 'background-repeat: no-repeat;'
				+ 'border:none;'
		});
		
		return fn.westPanel;
	}, 
	getLogininPanel: function () {
		var fn = this;
		fn.loginPanel = Ext.create('Ext.panel.Panel', {
			cls: 'as-page-panel',
			width: 600,
			border: false,
			defaults: {
				width: 300,
				labelWidth: AS.ARC.config.layout.labelWidthSmall,
			},
			/*style: 'background-image: url("' + fn.imageUrl + 'back.png");' +
					'background-repeat: no-repeat;'+
					' background-position: right bottom;'+
					'border:none;',*/
			items: [{
				xtype: 'displayfield',
				itemId:'signinString',
				width: 600,
				fieldStyle: {fontSize:'18px'},
				value: '<b>'+_S('ASUS_SYNC_AGENT','SIGN_IN') + '</b>'
			},{
				xtype: 'displayfield',
				value: '<hr width= 560 style="border:1px height:2px color = #777777">'
			},{
				xtype: 'textfield',
				itemId: 'id',
				height: 38,
				emptyText:_S('ASUS_SYNC_AGENT','WEB_STORAGE_ID'),
				border:'0',
				width: 240,
				fieldStyle: 'background-image: url("' + fn.imageUrl + 'id.png");' +
                    'background-size: 230px 38px;' +
					'background-repeat: no-repeat;'+
					'  margin-left: 160px;'+
					'  margin-top: 10px;'+
					'  padding-right: 12px;'+
					'  padding-left: 35px;'+'border:none;',
				listeners:{
					render: function(text){
						if(text.getValue()!='' && fn.loginPanel.items.get('password').getValue()!=''){
							fn.loginPanel.items.get('signin').enable();
						}else{
							fn.loginPanel.items.get('signin').disable();
						}
					},
					change:function(text){
						fn.storageId = text.getValue();
						if(text.getValue()!='' && fn.loginPanel.items.get('password').getValue()!=''){
							fn.loginPanel.items.get('signin').enable();
						}else{
							fn.loginPanel.items.get('signin').disable();
						}
					}
				}
			},{
				xtype: 'textfield',
				margin: '10 0 0 0',
				itemId: 'password',
				inputType:'password',
				height: 38,
				width: 240,
				emptyText:_S('COMMON','PWD'),
				fieldStyle: 'background-image: url("' + fn.imageUrl + 'pwd.png");' +
					'background-size: 230px 38px;' +
                    'background-repeat: no-repeat;'+
					'  margin-left: 160px;'+
					'  margin-top: 10px;'+
					'  padding-right: 12px;'+
					'padding-left: 35px;'+'border:none;',
				listeners:{
					render: function(text){
						if(text.getValue()!='' && fn.loginPanel.items.get('id').getValue()!=''){
							fn.loginPanel.items.get('signin').enable();
						}else{
							fn.loginPanel.items.get('signin').disable();
						}
					},
					change:function(text){
						fn.storagePwd = text.getValue();
						if(text.getValue()!='' && fn.loginPanel.items.get('id').getValue()!=''){
							fn.loginPanel.items.get('signin').enable();
						}else{
							fn.loginPanel.items.get('signin').disable();
						}
					}
				}
			},{
				xtype: 'button',
				margin: '30 0 0 160',
				width: 230,
				height: 41,
				disabled: false,
				itemId: 'signin',
				text: _S('ASUS_SYNC_AGENT','SIGN_IN'),
				style: 'background-image: url("' + fn.imageUrl + 'login1.png");' +
					'background-size: 230px 41px;' +
                    'background-repeat: no-repeat;'+
					'padding-top: 5px;' +'border:none;',
				handler: function(btn) {
					fn.win.el.mask(_S('COMMON','LOADING'));
					var btn = this;

					if(btn.getText() == _S('ASUS_SYNC_AGENT','SIGN_IN')){
						var urlOpts = {
							act: 'login',
							uid: fn.loginPanel.items.get('id').getValue(),
							pwd: fn.loginPanel.items.get('password').getValue()
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,urlOpts),
							method: 'post',
							success: function (json, opts) {
								fn.loginPanel.items.get('signinString').setValue('<b>'+_S('ASUS_SYNC_AGENT','WELCOME') + '</b>');
								fn.loginPanel.items.get('id').disable();
								fn.loginPanel.items.get('password').disable();
								fn.loginPanel.dockedItems.items[0].items.get('advance').hide();
								btn.setText(_S('ASUS_SYNC_AGENT','SIGN_OUT'));
								fn.location = json.vir_dir;
								Ext.fly(fn.loginPanel.items.get('locationData').items.get('location').id).dom.setAttribute('data-qtip',json.vir_dir);
								fn.loginPanel.items.get('locationData').items.get('location').setValue('home/ASUS/.../MySyncFolder');
								fn.loginPanel.items.get('locationData').show();
								fn.win.el.unmask();
							},
							failure: function (json, opts) {
								AS.ARC.util.showMsgWindow({
									5014: _S('ASUS_SYNC_AGENT', 'PWD_ACCOUNT_INCORRECT'),
									5018: _S('ASUS_SYNC_AGENT', 'PWD_ACCOUNT_INCORRECT'),
									5039: _S('ASUS_SYNC_AGENT', 'UNABLE_CONNECT_INTERNET'),
									5608: _S('ASUS_SYNC_AGENT', 'CONNECTION_TIMEOUT')
									
								}, json, fn.win);

							}
						});
					}else{
						var urlOpts = {
							act: 'logout'
						};
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,urlOpts),
							method: 'post',
							success: function (json, opts) {
								fn.loginPanel.items.get('signinString').setValue('<b>'+_S('ASUS_SYNC_AGENT','SIGN_IN') + '</b>');
								fn.loginPanel.items.get('id').enable();
								fn.loginPanel.items.get('password').enable();
								btn.setText(_S('ASUS_SYNC_AGENT','SIGN_IN'));
								fn.loginPanel.dockedItems.items[0].items.get('advance').show();
								fn.loginPanel.items.get('locationData').hide();
								fn.win.el.unmask();
							},
							failure: function (json, opts) {
								AS.ARC.util.showMsgWindow({
									5018: _S('ASUS_SYNC_AGENT', 'PARAMETERS_INCORRECT')
								}, json, fn.win);
							}
						});
					}
				}
			},{
				xtype: 'container',
				itemId: 'locationData',
				margin: '30 0 0 0',
				width: 560,
				height:106,
				style: 'background-image: url("' + fn.imageUrl + 'back_line.png");' +
						'border:none;',
				layout: {
					type: 'hbox',
				},
				items:[{
					xtype: 'displayfield',
					itemId: 'location',
					width: 410,
					margin:'20 0 0 10',
					fieldStyle: 'overflow: hidden; text-overflow: ellipsis; white-space: nowrap; width: inherit;',
					labelWidth: AS.ARC.config.layout.labelWidthMedium -20,
					fieldLabel: _S('ASUS_SYNC_AGENT','WEB_STORAGE_LOCATION'),
					value: '/home/ASUS/.../MySyncFolder'
				},{
					xtype: 'button',
					margin: '20 0 0 10',
					text: _S('NETWORK','OPEN'),
					handler: function() {
						AS.ARC.core.openApp('app-fileExplorer',fn.location);
					}
				}]
			}],
			fbar:[{
				xtype: 'button',
				width: 150,
				itemId: 'advance',
				// style: 'background-image: url("' + fn.imageUrl + 'advance.png");' +
					// 'padding-top: 5px;' +'border:none;',
				text: _S('COMMON','ADVANCED'),
				handler: function() {
					fn.getAdvanceWindow();
				}
			}]
		});
		return fn.loginPanel;
	},
	getAdvanceWindow: function(){
		var fn = this;
		
		var buttonApply = Ext.create('Ext.button.Button', {
			itemId: 'apply',
			text: _S('COMMON','APPLY'),
			handler: function() {
				var items = win.items.get('panel').items,
					proxy =  items.get('no_proxy').getValue() ? false : true;
				var urlOpts = {
					act: 'edit_setting',
					enableproxy: proxy,
					proxyurl: items.get('url').getValue(),
					proxyport: items.get('port').getValue(),
					enableauthentication: items.get('authentication').getValue(),
					proxyuid: items.get('username').getValue(),
					proxypwd: items.get('userpwd').getValue()
				};
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,urlOpts),
					method: 'post',
					success: function (json, opts) {
						win.close();
					},
					failure: function (json, opts) {
						AS.ARC.util.showMsgWindow({
							5302: _S('ASUS_SYNC_AGENT', 'PARAMETERS_INVALID'),
							5401: _S('ASUS_SYNC_AGENT', 'CONFIG_ERROR')
						}, json, win);
					}
				});
			}
		});
		
		var win = Ext.create('AS.ARC.subWindow', {
			parentWin: fn.win,
			title: _S('COMMON', 'PREFERENCES'),
			width: 600,
			height: 370,
			items: [{
				xtype: 'asPanelTop20',
				itemId: 'panel',
				buttonApply: buttonApply,
				width: 600,
				height: 270,
				defaults: {
					//margin:'10 0 0 20',
					msgTarget: 'side'
				},
				items:[{
					xtype: 'radio',
					boxLabel : _S('ASUS_SYNC_AGENT','NO_PROXY'),
					itemId: 'no_proxy',
                    name      : 'proxy',
					inputValue: false, 
					checked:true,
					listeners:{
						change: function(radio, newValue, oldValue, eOpts){
							var items = win.items.get('panel').items;
							if(newValue){
								items.get('url').disable();
								items.get('port').disable();
								items.get('port').clearInvalid();
								items.get('authentication').disable();
								items.get('username').disable();
								items.get('userpwd').disable();
							}else{
								items.get('url').enable();
								items.get('port').enable();
								items.get('port').clearInvalid();
								items.get('port').isValid();
								items.get('authentication').enable();
								if(items.get('authentication').getValue()){
									items.get('username').enable();
									items.get('userpwd').enable();
								}else{
									items.get('username').disable();
									items.get('userpwd').disable();
								}
							}
						}
					}
				},{
					xtype: 'radio',
					itemId: 'manual_proxy',
					boxLabel : _S('ASUS_SYNC_AGENT','MANUAL_PROXY'),
                    name      : 'proxy',
					inputValue: true, 
				},{
					xtype: 'textfield',
					width: 200,
					itemId: 'url',
					emptyText:_S('ASUS_SYNC_AGENT','HTTP_PROXY_URL'),
				},{
					xtype: 'numberfield',
					itemId: 'port',
					width: 200,
					maxValue: 65535,
					minValue: 1,
					minText: _S('MESSAGE', 'HF00025'),
					maxText: _S('MESSAGE', 'HF00024'),
					allowDecimals: false,
					allowExponential: false,
					nanText: _S('MESSAGE', 'HF00027'),
					emptyText:_S('ASUS_SYNC_AGENT','PORT'),
				},{
					xtype: 'checkbox',
					itemId: 'authentication',
					boxLabel  :_S('ASUS_SYNC_AGENT','AUTHENTICATION'),
					listeners:{
						change: function(radio, newValue, oldValue, eOpts){
							var items = win.items.get('panel').items;
							if(newValue){
								items.get('username').enable();
								items.get('userpwd').enable();
							}else{
								items.get('username').disable();
								items.get('userpwd').disable();
							}
						}
					}
				},{
					xtype: 'textfield',
					width: 200,
					itemId: 'username',
					emptyText:_S('COMMON','USERNAME'),
				},{
					xtype: 'textfield',
					width: 200,
					itemId: 'userpwd',
					emptyText:_S('COMMON','PWD'),
				}]
				
			}],
			fbar:[
				buttonApply, 
			{
				xtype: 'button',
				disabled: false,
				itemId: 'cancel',
				text: _S('COMMON','CANCEL'),
				handler: function() {
					win.close();
				}
			}],
			listeners:{
				beforeshow:function(win){
					var items = win.items.get('panel').items;
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act: 'get_proxy_setting'}),
						method: 'post',
						success: function (json, opts) {
							items.get('url').setValue(json.proxyurl);
							items.get('port').setValue(json.proxyport);
							items.get('authentication').setValue(json.enableauthentication);
							items.get('username').setValue(json.proxyuid);
							items.get('userpwd').setValue(json.proxypwd);
							
							if(!json.enableproxy){
								items.get('no_proxy').setValue(true);
								items.get('url').disable();
								items.get('port').disable();
								items.get('authentication').disable();
								items.get('username').disable();
								items.get('userpwd').disable();
							}else{
								items.get('manual_proxy').setValue(true);
								items.get('url').enable();
								items.get('port').enable();
								if(json.enableauthentication){
									items.get('authentication').enable();
									items.get('username').enable();
									items.get('userpwd').enable();
								}else{
									items.get('username').disable();
									items.get('userpwd').disable();
								}
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5006: _S('ASUS_SYNC_AGENT', 'UNABLE_READ_CONFIG')
							}, json, win);
						}
					});
					
				}
			}
		});
		win.show();
	},
	getMainPanel: function () {
		var fn = this;
		
		fn.mainPanel = Ext.create('Ext.container.Container', {
			cls: 'as-page-panel',
			region: 'center',
			height: 500,
			width: 600,
			border: false,
			layout: {
				type: 'card'
			},
			activeItem: 0,
			/*style: 'background-image: url("' + fn.imageUrl + 'back.png");' +
					'background-repeat: no-repeat;'+
					' background-position: right bottom;'+
					'border:none;',*/
			items: [
				fn.getLogininPanel(),
			],
			loadData: function () {
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act: 'get_user_setting'}),
					method: 'post',
					success: function (json, opts) {
						var items = fn.loginPanel.items;
						if(json.uid != ''){
							items.get('id').setValue(json.uid);
						}
						if(json.pwd != ''){
							items.get('password').setValue(json.pwd);
						}
						
						if(json.enablelogin){
							items.get('signinString').setValue('<b>'+_S('ASUS_SYNC_AGENT','WELCOME') + '</b>');
							items.get('id').disable();
							items.get('password').disable();
							items.get('signin').setText(_S('ASUS_SYNC_AGENT','SIGN_OUT'));
							Ext.fly(items.get('locationData').items.get('location').id).dom.setAttribute('data-qtip',json.vir_dir);
							items.get('locationData').items.get('location').setValue('home/ASUS/.../MySyncFolder');
							items.get('locationData').show();
							fn.location = json.vir_dir;
							fn.loginPanel.dockedItems.items[0].items.get('advance').hide();
							
						}else{
							items.get('signinString').setValue('<b>'+_S('ASUS_SYNC_AGENT','SIGN_IN') + '</b>');
							items.get('id').enable();
							items.get('password').enable();
							items.get('signin').setText(_S('ASUS_SYNC_AGENT','SIGN_IN'));
							items.get('locationData').hide();
							fn.loginPanel.dockedItems.items[0].items.get('advance').show();
						}
					},
					failure: function (json, opts) {
						AS.ARC.util.showMsgWindow({
							5006: _S('ASUS_SYNC_AGENT', 'UNABLE_READ_CONFIG')
						}, json, win);
					}
				});
			}
		});
		
		return fn.mainPanel;
	}
});

/**
 * @class AS.ARC.apps.asusSyncAgent.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('AS.ARC.apps.asusSyncAgent.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'asus-sync-agent',
	title: 'Asus Sync Agent',
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],
	
	createWindow: function () {
		var desktop = this.core.getDesktop(),			
			app = this;
		
		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}
		
		// Set appIsReady to false
		this.appIsReady = false;

		var asusSyncAgent = new AS.ARC.apps.asusSyncAgent.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
		});
		
		asusSyncAgent.win.on('render', function () {
			app.appOpenNum++;
			app.appIsReady = true;
		});		
	
		asusSyncAgent.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
			app.appWins.pop();

		});		
		asusSyncAgent.win.show();
		
		// Get all wins for handling
		this.appWins.push(asusSyncAgent.win);
	},
	onClose: function () {

	}
});